// KreateCD - CD recording software for the K desktop environment
//
// 1999-2000 by Alexander Feigl <Alexander.Feigl@gmx.de>
//
// This file is subject to the terms and conditions of the GNU General      
// Public License.  See the file COPYING in the main directory of the       
// KreateCD distribution for more details.                                     


#include "TopWidget.h"
#include "CDTrack.h"
#include "ConfPath.h"

#include <kapp.h>
#include <klocale.h>

#include <qmessagebox.h>

#include <unistd.h>

TopWidget *MainWin;

int callUID,callGID;

int dropRootRights(void)
 {
  long int nomod=-1;
  if (setreuid(nomod,callUID)) return(0);
  if (setregid(nomod,callGID)) return(0);
  return(1);
 }

int getRootRights(void)
 {
  long int nomod=-1;
  if (setreuid(nomod,0)) return(0);
  if (setregid(nomod,0)) return(0);
  return(1);
 }

int main(int argc,char **argv)
 {
  int e1,e2,e3;
  callUID=getuid();
  callGID=getgid();
  e1=dropRootRights();
  e2=getRootRights();
  e3=dropRootRights();

   {
    KApplication KreateCDApp(argc,argv,"kreatecd");

#if QT_VERSION >= 200
    if ( (!e1) || (!e2) ||(!e3) )
     {
      QMessageBox::critical(0,QString::null,i18n("Must run as root or set-UID root!"));
      return(0);
     }
  
    if (!ConfPath::verifyPrograms())
     {
      QMessageBox::warning(0,QString::null,i18n("Warning : some programs needed by KreateCD\nwere not found!\n\n"
                                             "Please visit the path configuration!"));
     }
#else
    if ( (!e1) || (!e2) ||(!e3) )
     {
      QMessageBox::critical(0,0,i18n("Must run as root or set-UID root!"));
      return(0);
     }

    if (!ConfPath::verifyPrograms())
     {
      QMessageBox::warning(0,0,i18n("Warning : some programs needed by KreateCD\nwere not found!\n\n"
                                             "Please visit the path configuration!"));
     }
#endif
    
#if QT_VERSION < 200
    KreateCDApp.enableSessionManagement(FALSE);
#endif

    MainWin=new TopWidget();
    KreateCDApp.setMainWidget(MainWin);
    KreateCDApp.setTopWidget(MainWin);

    MainWin->show(); 
    return(KreateCDApp.exec());
   }
 }
